# SimpliBox IO python code example
# visit www.hwhardsoft.de for more information
#
# communication with HID using pyUSB
# git clone https://github.com/walac/pyusb.git 
# cd pyusb
# sudo python setup.py
# Windows needs libusb! (http://sourceforge.net/projects/libusb-win32)
Vendor_ID = 0x16C0 # VUSB VID
Product_ID = 0x05DF # VUSB PID for HID

import usb.core, time

interface = 0
dev = usb.core.find(idVendor = Vendor_ID,idProduct = Product_ID)
if dev is None:
    print "device not found"

# only linux: uncomment if device not free (error resource busy)   
if dev.is_kernel_driver_active(interface) is True:    
    dev.detach_kernel_driver(interface)        
    usb.util.claim_interface(dev, interface)        
    dev = usb.core.find(idVendor = Vendor_ID,idProduct = Product_ID)


dev.set_configuration()



# read opto isolated inputs
# using HID class request: "Get report"
ret = dev.ctrl_transfer(0xA1, 0x01, 0x03, 0, 3)

if ret[1] & 0x40 :	# status of input 1
    print "Input 1 is closed"
else:
    print "Input 1 is opened"

if ret[1] & 0x80 :	# status of input 2
    print "Input 2 is closed"
else:
    print "Input 2 is opened"


#set relay outputs 
#using HID class request: "Set report"

#set relay 1
datapack= 0x01, 0x00, 0x10
ret = dev.ctrl_transfer(0x21, 0x09, 0x03, 0, datapack)
time.sleep(1) #wait 1 sec

#set relay 2
datapack = 0x01, 0x00, 0x01
ret = dev.ctrl_transfer(0x21, 0x09, 0x03, 0, datapack)
time.sleep(1) #wait 1 sec

#set both relays
datapack = 0x01, 0x00, 0x11
ret = dev.ctrl_transfer(0x21, 0x09, 0x03, 0, datapack)
time.sleep(1) #wait 1 sec

#unset both relays
datapack = 0x01, 0x00, 0x00
ret = dev.ctrl_transfer(0x21, 0x09, 0x03, 0, datapack)
time.sleep(1) #wait 1 sec
